import { Emce } from 'emce';
import { Selector } from './selector';
import { Observable } from 'rxjs/Observable';
export interface EmceSelect<T> extends Emce<T> {
    select<U>(selector: Selector<T, U>): Observable<U>;
    select<a extends keyof T>(property: a): Observable<T[a]>;
    select<a extends keyof T, b extends keyof T[a]>(property: a, property2: b): Observable<T[a][b]>;
    select<a extends keyof T, b extends keyof T[a], c extends keyof T[a][b]>(property: a, property2: b, property3: c): Observable<T[a][b][c]>;
    select<a extends keyof T, b extends keyof T[a], c extends keyof T[a][b], d extends keyof T[a][b][c]>(property: a, property2: b, property3: c, property4: d): Observable<T[a][b][c][d]>;
    select<a extends keyof T, b extends keyof T[a], c extends keyof T[a][b], d extends keyof T[a][b][c], e extends keyof T[a][b][c][d]>(property: a, property2: b, property3: c, property4: d, property5: e): Observable<T[a][b][c][d][e]>;
    select<U>(selectorOrProperty: string | Selector<T, U>, ...properties: string[]): Observable<U>;
}
